class Number
  @value

  def initialize(v)
    @value = v
  end

  def value
    # the number
    @value.to_i
  end

  def to_s
    @value.to_s
  end

  def squee
    "squee" + "e" * value.to_i
  end
end

class Point
  @x
  @y

  def initialize(x,y)
    @x = x
    @y = y
  end

  def x
    @x
  end

  def y
    @y
  end

  def to_s
    "(" + @x.to_s + "," + @y.to_s + ")"
  end
end

class Rectangle
  @topleft
  @bottomright

  def initialize(tl, br)
    @topleft = tl
    @bottomright = br
  end

  def to_s
    "[" + @topleft.to_s + "," + @bottomright.to_s + "]"
  end

  def value
    # the area
    length_y = @topleft.y.value - @bottomright.y.value
    length_x = @bottomright.x.value - @topleft.x.value
    length_y * length_x
  end
end

p1 = Point.new(Number.new(1),Number.new(4))
p2 = Point.new(Number.new(3),Number.new(2))
r1 = Rectangle.new(p1,p2)

puts p1
puts p2
puts r1
puts "area of r1 is " + r1.value.to_s

### NEW STUFF ###

class RationalNumber < Number
  @numerator
  @denominator

  def initialize(n,d)
    @numerator = n
    @denominator = d
  end

  def value
    @numerator / @denominator
  end

  def to_s
    @numerator.to_s + "/" + @denominator.to_s
  end
end

p3 = Point.new(RationalNumber.new(1,1),RationalNumber.new(4,1))
p4 = Point.new(RationalNumber.new(3,1),RationalNumber.new(2,1))
r2 = Rectangle.new(p3,p4)

puts p3
puts p4
puts r2
puts "area of r2 is " + r2.value.to_s
